﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core.Views;
using HeuristicLab.Data;
using HeuristicLab.MainForm;

namespace HeuristicLab.Encodings.ParameterConfigurationEncoding.Views {
  /// <summary>
  /// The visual representation of a <see cref="IRange"/>.
  /// </summary>
  [View("Range View")]
  [Content(typeof(IRange<>), false)]
  public partial class RangeView : ItemView {
    /// <summary>
    /// Gets or sets the variable to represent visually.
    /// </summary>
    public new IRange Content {
      get { return (IRange)base.Content; }
      set { base.Content = value; }
    }

    public RangeView() {
      InitializeComponent();
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      if (Content != null) {
        lowerValueView.Content = (IStringConvertibleValue)Content.LowerBound;
        upperValueView.Content = (IStringConvertibleValue)Content.UpperBound;
        stepSizeValueView.Content = (IStringConvertibleValue)Content.StepSize;
      } else {
        lowerValueView.Content = null;
        upperValueView.Content = null;
        stepSizeValueView.Content = null;
      }
    }
  }
}
